;nyquist plug-in
;version 1
;type process
;name "FUZZ BuStEr"
;action "FiLtErInG...."
;info "<5MLAbZ>"

;control Frq1 "T01:[FREQ]:" real "[Hz]" 0 0 20000
;control Cur2 "TIME 02:" real "s.ms" 0 0 0.999
;control Frq2 " [FREQ]:" real "[Hz]" 0 0 20000
;control Cur3 "TIME 03:" real "s.ms" 0 0 0.999
;control Frq3 " [FREQ]:" real "[Hz]" 0 0 20000
;control Cur4 "TIME 04:" real "s.ms" 0 0 0.999
;control Frq4 " [FREQ]:" real "[Hz]" 0 0 20000
;control Cur5 "TIME 05:" real "s.ms" 0 0 0.999
;control Frq5 " [FREQ]:" real "[Hz]" 0 0 20000
;control Cur6 "TIME 06:" real "s.ms" 0 0 0.999
;control Frq6 " [FREQ]:" real "[Hz]" 0 0 20000
;control Cur7 "TIME 07:" real "s.ms" 0 0 0.999
;control Frq7 " [FREQ]:" real "[Hz]" 0 0 20000
;control Cur8 "TIME 08:" real "s.ms" 0 0 0.999
;control Frq8 " [FREQ]:" real "[Hz]" 0 0 20000
;control Frq9 "T09:[FREQ]:" real "[Hz]" 0 0 20000

(defun calc-cp (cp)
   (/ cp (/ LEN *sound-srate*)))

; initialize cp variables
(setq cp2 (calc-cp cur2))
(setq cp3 (calc-cp cur3))
(setq cp4 (calc-cp cur4))
(setq cp5 (calc-cp cur5))
(setq cp6 (calc-cp cur6))
(setq cp7 (calc-cp cur7))
(setq cp8 (calc-cp cur8))
(setq cp9 1.0)

(setq ffl (list Frq1)) ; initialize filter list
(setq lcp 0)

; function to add points to frequency envelope list
(defun addpoints (env cp frq)
   (setq lcp cp)
   (append env (list cp frq)))

(if (or (> cp2 0)(> cp2 lcp)) 
   (setf ffl (addpoints ffl cp2 Frq2)))
   
(if (or (> cp3 0)(> cp3 lcp)) 
   (setf ffl (addpoints ffl cp3 Frq3)))

(if (or (> cp4 0)(> cp4 lcp)) 
   (setf ffl (addpoints ffl cp4 Frq4)))

(if (or (> cp5 0)(> cp5 lcp)) 
   (setf ffl (addpoints ffl cp5 Frq5)))

(if (or (> cp6 0)(> cp6 lcp)) 
   (setf ffl (addpoints ffl cp6 Frq6)))

(if (or (> cp7 0)(> cp7 lcp)) 
   (setf ffl (addpoints ffl cp7 Frq7)))

(if (or (> cp8 0)(> cp8 lcp)) 
   (setf ffl (addpoints ffl cp8 Frq8)))

(setf ffl (addpoints ffl cp9 Frq9))

(print ffl) ; outputs the envelope list in the debug window

(lp s (pwlvr-list ffl))